/**
 * @packageDocumentation
 * @module echo_rpc
 * @mergeTarget
 */
import * as model from "./model";
import * as eventstream_rpc from "../eventstream_rpc";
export { model };
export declare class Client {
    private rpcClient;
    private serviceModel;
    constructor(config: eventstream_rpc.RpcClientConfig);
    connect(): Promise<void>;
    close(): void;
    echoMessage(request: model.EchoMessageRequest, options?: eventstream_rpc.OperationOptions): Promise<model.EchoMessageResponse>;
    causeServiceError(request: model.CauseServiceErrorRequest, options?: eventstream_rpc.OperationOptions): Promise<model.CauseServiceErrorResponse>;
    getAllCustomers(request: model.GetAllCustomersRequest, options?: eventstream_rpc.OperationOptions): Promise<model.GetAllCustomersResponse>;
    getAllProducts(request: model.GetAllProductsRequest, options?: eventstream_rpc.OperationOptions): Promise<model.GetAllProductsResponse>;
    echoStreamMessages(request: model.EchoStreamingRequest, options?: eventstream_rpc.OperationOptions): eventstream_rpc.StreamingOperation<model.EchoStreamingRequest, model.EchoStreamingResponse, model.EchoStreamingMessage, model.EchoStreamingMessage>;
    causeStreamServiceToError(request: model.EchoStreamingRequest, options?: eventstream_rpc.OperationOptions): eventstream_rpc.StreamingOperation<model.EchoStreamingRequest, model.EchoStreamingResponse, model.EchoStreamingMessage, model.EchoStreamingMessage>;
}
