"use strict";
/*
 * Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * SPDX-License-Identifier: Apache-2.0.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.serializeGetAllCustomersRequestToEventstreamMessage = exports.validateGetAllCustomersRequest = exports.deserializeGetAllCustomersRequest = exports.normalizeGetAllCustomersRequest = exports.serializeEchoStreamingMessageToEventstreamMessage = exports.deserializeEventstreamMessageToEchoStreamingMessage = exports.validateEchoStreamingMessage = exports.deserializeEchoStreamingMessage = exports.normalizeEchoStreamingMessage = exports.deserializeEventstreamMessageToEchoStreamingResponse = exports.validateEchoStreamingResponse = exports.deserializeEchoStreamingResponse = exports.normalizeEchoStreamingResponse = exports.serializeEchoStreamingRequestToEventstreamMessage = exports.validateEchoStreamingRequest = exports.deserializeEchoStreamingRequest = exports.normalizeEchoStreamingRequest = exports.validateCustomer = exports.deserializeCustomer = exports.normalizeCustomer = exports.deserializeEventstreamMessageToServiceError = exports.validateServiceError = exports.deserializeServiceError = exports.normalizeServiceError = exports.deserializeEventstreamMessageToCauseServiceErrorResponse = exports.validateCauseServiceErrorResponse = exports.deserializeCauseServiceErrorResponse = exports.normalizeCauseServiceErrorResponse = exports.serializeCauseServiceErrorRequestToEventstreamMessage = exports.validateCauseServiceErrorRequest = exports.deserializeCauseServiceErrorRequest = exports.normalizeCauseServiceErrorRequest = exports.deserializeEventstreamMessageToEchoMessageResponse = exports.validateEchoMessageResponse = exports.deserializeEchoMessageResponse = exports.normalizeEchoMessageResponse = exports.serializeEchoMessageRequestToEventstreamMessage = exports.validateEchoMessageRequest = exports.deserializeEchoMessageRequest = exports.normalizeEchoMessageRequest = exports.validateMessageData = exports.deserializeMessageData = exports.normalizeMessageData = exports.validateProduct = exports.deserializeProduct = exports.normalizeProduct = exports.validatePair = exports.deserializePair = exports.normalizePair = exports.makeServiceModel = void 0;
exports.deserializeEventstreamMessageToGetAllProductsResponse = exports.validateGetAllProductsResponse = exports.deserializeGetAllProductsResponse = exports.normalizeGetAllProductsResponse = exports.serializeGetAllProductsRequestToEventstreamMessage = exports.validateGetAllProductsRequest = exports.deserializeGetAllProductsRequest = exports.normalizeGetAllProductsRequest = exports.deserializeEventstreamMessageToGetAllCustomersResponse = exports.validateGetAllCustomersResponse = exports.deserializeGetAllCustomersResponse = exports.normalizeGetAllCustomersResponse = void 0;
const eventstream_rpc_utils = __importStar(require("../eventstream_rpc_utils"));
const aws_crt_1 = require("aws-crt");
const util_utf8_browser_1 = require("@aws-sdk/util-utf8-browser");
function createNormalizerMap() {
    return new Map([
        ["awstest#Pair", normalizePair],
        ["awstest#Product", normalizeProduct],
        ["awstest#MessageData", normalizeMessageData],
        ["awstest#EchoMessageRequest", normalizeEchoMessageRequest],
        ["awstest#EchoMessageResponse", normalizeEchoMessageResponse],
        ["awstest#CauseServiceErrorRequest", normalizeCauseServiceErrorRequest],
        ["awstest#CauseServiceErrorResponse", normalizeCauseServiceErrorResponse],
        ["awstest#ServiceError", normalizeServiceError],
        ["awstest#Customer", normalizeCustomer],
        ["awstest#EchoStreamingRequest", normalizeEchoStreamingRequest],
        ["awstest#EchoStreamingResponse", normalizeEchoStreamingResponse],
        ["awstest#EchoStreamingMessage", normalizeEchoStreamingMessage],
        ["awstest#GetAllCustomersRequest", normalizeGetAllCustomersRequest],
        ["awstest#GetAllCustomersResponse", normalizeGetAllCustomersResponse],
        ["awstest#GetAllProductsRequest", normalizeGetAllProductsRequest],
        ["awstest#GetAllProductsResponse", normalizeGetAllProductsResponse]
    ]);
}
function createValidatorMap() {
    return new Map([
        ["awstest#Pair", validatePair],
        ["awstest#Product", validateProduct],
        ["awstest#MessageData", validateMessageData],
        ["awstest#EchoMessageRequest", validateEchoMessageRequest],
        ["awstest#EchoMessageResponse", validateEchoMessageResponse],
        ["awstest#CauseServiceErrorRequest", validateCauseServiceErrorRequest],
        ["awstest#CauseServiceErrorResponse", validateCauseServiceErrorResponse],
        ["awstest#ServiceError", validateServiceError],
        ["awstest#Customer", validateCustomer],
        ["awstest#EchoStreamingRequest", validateEchoStreamingRequest],
        ["awstest#EchoStreamingResponse", validateEchoStreamingResponse],
        ["awstest#EchoStreamingMessage", validateEchoStreamingMessage],
        ["awstest#GetAllCustomersRequest", validateGetAllCustomersRequest],
        ["awstest#GetAllCustomersResponse", validateGetAllCustomersResponse],
        ["awstest#GetAllProductsRequest", validateGetAllProductsRequest],
        ["awstest#GetAllProductsResponse", validateGetAllProductsResponse]
    ]);
}
function createDeserializerMap() {
    return new Map([
        ["awstest#EchoMessageResponse", deserializeEventstreamMessageToEchoMessageResponse],
        ["awstest#CauseServiceErrorResponse", deserializeEventstreamMessageToCauseServiceErrorResponse],
        ["awstest#ServiceError", deserializeEventstreamMessageToServiceError],
        ["awstest#EchoStreamingResponse", deserializeEventstreamMessageToEchoStreamingResponse],
        ["awstest#EchoStreamingMessage", deserializeEventstreamMessageToEchoStreamingMessage],
        ["awstest#GetAllCustomersResponse", deserializeEventstreamMessageToGetAllCustomersResponse],
        ["awstest#GetAllProductsResponse", deserializeEventstreamMessageToGetAllProductsResponse]
    ]);
}
function createSerializerMap() {
    return new Map([
        ["awstest#EchoMessageRequest", serializeEchoMessageRequestToEventstreamMessage],
        ["awstest#CauseServiceErrorRequest", serializeCauseServiceErrorRequestToEventstreamMessage],
        ["awstest#EchoStreamingRequest", serializeEchoStreamingRequestToEventstreamMessage],
        ["awstest#EchoStreamingMessage", serializeEchoStreamingMessageToEventstreamMessage],
        ["awstest#GetAllCustomersRequest", serializeGetAllCustomersRequestToEventstreamMessage],
        ["awstest#GetAllProductsRequest", serializeGetAllProductsRequestToEventstreamMessage]
    ]);
}
function createOperationMap() {
    return new Map([
        ["awstest#EchoMessage", {
                requestShape: "awstest#EchoMessageRequest",
                responseShape: "awstest#EchoMessageResponse",
                errorShapes: new Set([])
            }],
        ["awstest#CauseServiceError", {
                requestShape: "awstest#CauseServiceErrorRequest",
                responseShape: "awstest#CauseServiceErrorResponse",
                errorShapes: new Set(["awstest#ServiceError"])
            }],
        ["awstest#CauseStreamServiceToError", {
                requestShape: "awstest#EchoStreamingRequest",
                responseShape: "awstest#EchoStreamingResponse",
                outboundMessageShape: "awstest#EchoStreamingMessage",
                inboundMessageShape: "awstest#EchoStreamingMessage",
                errorShapes: new Set(["awstest#ServiceError"])
            }],
        ["awstest#EchoStreamMessages", {
                requestShape: "awstest#EchoStreamingRequest",
                responseShape: "awstest#EchoStreamingResponse",
                outboundMessageShape: "awstest#EchoStreamingMessage",
                inboundMessageShape: "awstest#EchoStreamingMessage",
                errorShapes: new Set([])
            }],
        ["awstest#GetAllCustomers", {
                requestShape: "awstest#GetAllCustomersRequest",
                responseShape: "awstest#GetAllCustomersResponse",
                errorShapes: new Set(["awstest#ServiceError"])
            }],
        ["awstest#GetAllProducts", {
                requestShape: "awstest#GetAllProductsRequest",
                responseShape: "awstest#GetAllProductsResponse",
                errorShapes: new Set(["awstest#ServiceError"])
            }]
    ]);
}
const FruitEnumValues = new Set([
    "apl", "org", "ban", "pin"
]);
function createEnumsMap() {
    return new Map([
        ["FruitEnum", FruitEnumValues]
    ]);
}
function makeServiceModel() {
    return {
        normalizers: createNormalizerMap(),
        validators: createValidatorMap(),
        deserializers: createDeserializerMap(),
        serializers: createSerializerMap(),
        operations: createOperationMap(),
        enums: createEnumsMap()
    };
}
exports.makeServiceModel = makeServiceModel;
function normalizePair(pair) {
    let normalized = {};
    eventstream_rpc_utils.setDefinedProperty(normalized, 'key', pair.key);
    eventstream_rpc_utils.setDefinedProperty(normalized, 'value', pair.value);
    return normalized;
}
exports.normalizePair = normalizePair;
function deserializePair(pair) {
    return pair;
}
exports.deserializePair = deserializePair;
function validatePair(pair) {
    eventstream_rpc_utils.validateValueAsString(pair.key, 'key', 'Pair');
    eventstream_rpc_utils.validateValueAsString(pair.value, 'value', 'Pair');
}
exports.validatePair = validatePair;
function normalizeProduct(product) {
    let normalized = {};
    eventstream_rpc_utils.setDefinedProperty(normalized, 'name', product.name);
    eventstream_rpc_utils.setDefinedProperty(normalized, 'price', product.price);
    return normalized;
}
exports.normalizeProduct = normalizeProduct;
function deserializeProduct(product) {
    return product;
}
exports.deserializeProduct = deserializeProduct;
function validateProduct(product) {
    eventstream_rpc_utils.validateValueAsOptionalString(product.name, 'name', 'Product');
    eventstream_rpc_utils.validateValueAsOptionalNumber(product.price, 'price', 'Product');
}
exports.validateProduct = validateProduct;
function normalizeMessageData(messageData) {
    let normalized = {};
    eventstream_rpc_utils.setDefinedProperty(normalized, 'stringMessage', messageData.stringMessage);
    eventstream_rpc_utils.setDefinedProperty(normalized, 'booleanMessage', messageData.booleanMessage);
    eventstream_rpc_utils.setDefinedProperty(normalized, 'timeMessage', messageData.timeMessage, eventstream_rpc_utils.encodeDateAsNumber);
    eventstream_rpc_utils.setDefinedProperty(normalized, 'documentMessage', messageData.documentMessage);
    eventstream_rpc_utils.setDefinedProperty(normalized, 'enumMessage', messageData.enumMessage);
    eventstream_rpc_utils.setDefinedProperty(normalized, 'blobMessage', messageData.blobMessage, eventstream_rpc_utils.encodePayloadAsString);
    eventstream_rpc_utils.setDefinedProperty(normalized, 'stringListMessage', messageData.stringListMessage);
    eventstream_rpc_utils.setDefinedArrayProperty(normalized, 'keyValuePairList', messageData.keyValuePairList, normalizePair);
    eventstream_rpc_utils.setDefinedMapPropertyAsObject(normalized, 'stringToValue', messageData.stringToValue, normalizeProduct);
    return normalized;
}
exports.normalizeMessageData = normalizeMessageData;
function deserializeMessageData(messageData) {
    eventstream_rpc_utils.setDefinedProperty(messageData, 'timeMessage', messageData.timeMessage, eventstream_rpc_utils.transformNumberAsDate);
    eventstream_rpc_utils.setDefinedProperty(messageData, 'blobMessage', messageData.blobMessage, eventstream_rpc_utils.transformStringAsPayload);
    eventstream_rpc_utils.setDefinedArrayProperty(messageData, 'keyValuePairList', messageData.keyValuePairList, deserializePair);
    eventstream_rpc_utils.setDefinedObjectPropertyAsMap(messageData, 'stringToValue', messageData.stringToValue, deserializeProduct);
    return messageData;
}
exports.deserializeMessageData = deserializeMessageData;
function validateMessageData(messageData) {
    eventstream_rpc_utils.validateValueAsOptionalString(messageData.stringMessage, 'stringMessage', 'MessageData');
    eventstream_rpc_utils.validateValueAsOptionalBoolean(messageData.booleanMessage, 'booleanMessage', 'MessageData');
    eventstream_rpc_utils.validateValueAsOptionalDate(messageData.timeMessage, 'timeMessage', 'MessageData');
    eventstream_rpc_utils.validateValueAsOptionalEnum(messageData.enumMessage, FruitEnumValues, 'enumMessage', 'MessageData');
    eventstream_rpc_utils.validateValueAsOptionalBlob(messageData.blobMessage, 'blobMessage', 'MessageData');
    eventstream_rpc_utils.validateValueAsOptionalArray(messageData.stringListMessage, eventstream_rpc_utils.validateValueAsString, 'stringListMessage', 'MessageData');
    eventstream_rpc_utils.validateValueAsOptionalArray(messageData.keyValuePairList, validatePair, 'keyValuePairList', 'MessageData');
    eventstream_rpc_utils.validateValueAsOptionalMap(messageData.stringToValue, validateProduct, 'stringToValue', 'MessageData');
}
exports.validateMessageData = validateMessageData;
function normalizeEchoMessageRequest(echoMessageRequest) {
    let normalized = {};
    eventstream_rpc_utils.setDefinedProperty(normalized, 'message', echoMessageRequest.message, normalizeMessageData);
    return normalized;
}
exports.normalizeEchoMessageRequest = normalizeEchoMessageRequest;
function deserializeEchoMessageRequest(echoMessageRequest) {
    eventstream_rpc_utils.setDefinedProperty(echoMessageRequest, 'message', echoMessageRequest.message, deserializeMessageData);
    return echoMessageRequest;
}
exports.deserializeEchoMessageRequest = deserializeEchoMessageRequest;
function validateEchoMessageRequest(echoMessageRequest) {
    eventstream_rpc_utils.validateValueAsOptionalObject(echoMessageRequest.message, validateMessageData, 'message', 'EchoMessageRequest');
}
exports.validateEchoMessageRequest = validateEchoMessageRequest;
function serializeEchoMessageRequestToEventstreamMessage(echoMessageRequest) {
    return {
        type: aws_crt_1.eventstream.MessageType.ApplicationMessage,
        payload: JSON.stringify(normalizeEchoMessageRequest(echoMessageRequest))
    };
}
exports.serializeEchoMessageRequestToEventstreamMessage = serializeEchoMessageRequestToEventstreamMessage;
function normalizeEchoMessageResponse(echoMessageResponse) {
    let normalized = {};
    eventstream_rpc_utils.setDefinedProperty(normalized, 'message', echoMessageResponse.message, normalizeMessageData);
    return normalized;
}
exports.normalizeEchoMessageResponse = normalizeEchoMessageResponse;
function deserializeEchoMessageResponse(echoMessageResponse) {
    eventstream_rpc_utils.setDefinedProperty(echoMessageResponse, 'message', echoMessageResponse.message, deserializeMessageData);
    return echoMessageResponse;
}
exports.deserializeEchoMessageResponse = deserializeEchoMessageResponse;
function validateEchoMessageResponse(echoMessageResponse) {
    eventstream_rpc_utils.validateValueAsOptionalObject(echoMessageResponse.message, validateMessageData, 'message', 'EchoMessageResponse');
}
exports.validateEchoMessageResponse = validateEchoMessageResponse;
function deserializeEventstreamMessageToEchoMessageResponse(message) {
    const payload_text = (0, util_utf8_browser_1.toUtf8)(new Uint8Array(message.payload));
    let response = JSON.parse(payload_text);
    return deserializeEchoMessageResponse(response);
}
exports.deserializeEventstreamMessageToEchoMessageResponse = deserializeEventstreamMessageToEchoMessageResponse;
function normalizeCauseServiceErrorRequest(causeServiceErrorRequest) {
    let normalized = {};
    return normalized;
}
exports.normalizeCauseServiceErrorRequest = normalizeCauseServiceErrorRequest;
function deserializeCauseServiceErrorRequest(causeServiceErrorRequest) {
    return causeServiceErrorRequest;
}
exports.deserializeCauseServiceErrorRequest = deserializeCauseServiceErrorRequest;
function validateCauseServiceErrorRequest(causeServiceErrorRequest) {
}
exports.validateCauseServiceErrorRequest = validateCauseServiceErrorRequest;
function serializeCauseServiceErrorRequestToEventstreamMessage(causeServiceErrorRequest) {
    return {
        type: aws_crt_1.eventstream.MessageType.ApplicationMessage,
        payload: JSON.stringify(normalizeCauseServiceErrorRequest(causeServiceErrorRequest))
    };
}
exports.serializeCauseServiceErrorRequestToEventstreamMessage = serializeCauseServiceErrorRequestToEventstreamMessage;
function normalizeCauseServiceErrorResponse(causeServiceErrorResponse) {
    let normalized = {};
    return normalized;
}
exports.normalizeCauseServiceErrorResponse = normalizeCauseServiceErrorResponse;
function deserializeCauseServiceErrorResponse(causeServiceErrorResponse) {
    return causeServiceErrorResponse;
}
exports.deserializeCauseServiceErrorResponse = deserializeCauseServiceErrorResponse;
function validateCauseServiceErrorResponse(causeServiceErrorResponse) {
}
exports.validateCauseServiceErrorResponse = validateCauseServiceErrorResponse;
function deserializeEventstreamMessageToCauseServiceErrorResponse(message) {
    const payload_text = (0, util_utf8_browser_1.toUtf8)(new Uint8Array(message.payload));
    let response = JSON.parse(payload_text);
    return deserializeCauseServiceErrorResponse(response);
}
exports.deserializeEventstreamMessageToCauseServiceErrorResponse = deserializeEventstreamMessageToCauseServiceErrorResponse;
function normalizeServiceError(serviceError) {
    let normalized = {};
    eventstream_rpc_utils.setDefinedProperty(normalized, 'message', serviceError.message);
    eventstream_rpc_utils.setDefinedProperty(normalized, 'value', serviceError.value);
    return normalized;
}
exports.normalizeServiceError = normalizeServiceError;
function deserializeServiceError(serviceError) {
    return serviceError;
}
exports.deserializeServiceError = deserializeServiceError;
function validateServiceError(serviceError) {
    eventstream_rpc_utils.validateValueAsOptionalString(serviceError.message, 'message', 'ServiceError');
    eventstream_rpc_utils.validateValueAsOptionalString(serviceError.value, 'value', 'ServiceError');
}
exports.validateServiceError = validateServiceError;
function deserializeEventstreamMessageToServiceError(message) {
    const payload_text = (0, util_utf8_browser_1.toUtf8)(new Uint8Array(message.payload));
    let response = JSON.parse(payload_text);
    return deserializeServiceError(response);
}
exports.deserializeEventstreamMessageToServiceError = deserializeEventstreamMessageToServiceError;
function normalizeCustomer(customer) {
    let normalized = {};
    eventstream_rpc_utils.setDefinedProperty(normalized, 'id', customer.id);
    eventstream_rpc_utils.setDefinedProperty(normalized, 'firstName', customer.firstName);
    eventstream_rpc_utils.setDefinedProperty(normalized, 'lastName', customer.lastName);
    return normalized;
}
exports.normalizeCustomer = normalizeCustomer;
function deserializeCustomer(customer) {
    return customer;
}
exports.deserializeCustomer = deserializeCustomer;
function validateCustomer(customer) {
    eventstream_rpc_utils.validateValueAsOptionalInteger(customer.id, 'id', 'Customer');
    eventstream_rpc_utils.validateValueAsOptionalString(customer.firstName, 'firstName', 'Customer');
    eventstream_rpc_utils.validateValueAsOptionalString(customer.lastName, 'lastName', 'Customer');
}
exports.validateCustomer = validateCustomer;
function normalizeEchoStreamingRequest(echoStreamingRequest) {
    let normalized = {};
    return normalized;
}
exports.normalizeEchoStreamingRequest = normalizeEchoStreamingRequest;
function deserializeEchoStreamingRequest(echoStreamingRequest) {
    return echoStreamingRequest;
}
exports.deserializeEchoStreamingRequest = deserializeEchoStreamingRequest;
function validateEchoStreamingRequest(echoStreamingRequest) {
}
exports.validateEchoStreamingRequest = validateEchoStreamingRequest;
function serializeEchoStreamingRequestToEventstreamMessage(echoStreamingRequest) {
    return {
        type: aws_crt_1.eventstream.MessageType.ApplicationMessage,
        payload: JSON.stringify(normalizeEchoStreamingRequest(echoStreamingRequest))
    };
}
exports.serializeEchoStreamingRequestToEventstreamMessage = serializeEchoStreamingRequestToEventstreamMessage;
function normalizeEchoStreamingResponse(echoStreamingResponse) {
    let normalized = {};
    return normalized;
}
exports.normalizeEchoStreamingResponse = normalizeEchoStreamingResponse;
function deserializeEchoStreamingResponse(echoStreamingResponse) {
    return echoStreamingResponse;
}
exports.deserializeEchoStreamingResponse = deserializeEchoStreamingResponse;
function validateEchoStreamingResponse(echoStreamingResponse) {
}
exports.validateEchoStreamingResponse = validateEchoStreamingResponse;
function deserializeEventstreamMessageToEchoStreamingResponse(message) {
    const payload_text = (0, util_utf8_browser_1.toUtf8)(new Uint8Array(message.payload));
    let response = JSON.parse(payload_text);
    return deserializeEchoStreamingResponse(response);
}
exports.deserializeEventstreamMessageToEchoStreamingResponse = deserializeEventstreamMessageToEchoStreamingResponse;
function normalizeEchoStreamingMessage(echoStreamingMessage) {
    let normalized = {};
    eventstream_rpc_utils.setDefinedProperty(normalized, 'streamMessage', echoStreamingMessage.streamMessage, normalizeMessageData);
    eventstream_rpc_utils.setDefinedProperty(normalized, 'keyValuePair', echoStreamingMessage.keyValuePair, normalizePair);
    return normalized;
}
exports.normalizeEchoStreamingMessage = normalizeEchoStreamingMessage;
const _echoStreamMessagePropertyDeserializers = new Map([
    ["streamMessage", deserializeMessageData],
    ["keyValuePair", deserializePair]
]);
function deserializeEchoStreamingMessage(echoStreamingMessage) {
    let union = {};
    eventstream_rpc_utils.setUnionProperty(union, echoStreamingMessage, _echoStreamMessagePropertyDeserializers);
    return union;
}
exports.deserializeEchoStreamingMessage = deserializeEchoStreamingMessage;
const _echoStreamMessagePropertyValidators = new Map([
    ["streamMessage", validateMessageData],
    ["keyValuePair", validatePair]
]);
function validateEchoStreamingMessage(echoStreamingMessage) {
    eventstream_rpc_utils.validateValueAsUnion(echoStreamingMessage, _echoStreamMessagePropertyValidators);
}
exports.validateEchoStreamingMessage = validateEchoStreamingMessage;
function deserializeEventstreamMessageToEchoStreamingMessage(message) {
    const payload_text = (0, util_utf8_browser_1.toUtf8)(new Uint8Array(message.payload));
    let response = JSON.parse(payload_text);
    return deserializeEchoStreamingMessage(response);
}
exports.deserializeEventstreamMessageToEchoStreamingMessage = deserializeEventstreamMessageToEchoStreamingMessage;
function serializeEchoStreamingMessageToEventstreamMessage(echoStreamingMessage) {
    return {
        type: aws_crt_1.eventstream.MessageType.ApplicationMessage,
        payload: JSON.stringify(normalizeEchoStreamingMessage(echoStreamingMessage))
    };
}
exports.serializeEchoStreamingMessageToEventstreamMessage = serializeEchoStreamingMessageToEventstreamMessage;
function normalizeGetAllCustomersRequest(getAllCustomersRequest) {
    let normalized = {};
    return normalized;
}
exports.normalizeGetAllCustomersRequest = normalizeGetAllCustomersRequest;
function deserializeGetAllCustomersRequest(getAllCustomersRequest) {
    return getAllCustomersRequest;
}
exports.deserializeGetAllCustomersRequest = deserializeGetAllCustomersRequest;
function validateGetAllCustomersRequest(getAllCustomersRequest) {
}
exports.validateGetAllCustomersRequest = validateGetAllCustomersRequest;
function serializeGetAllCustomersRequestToEventstreamMessage(getAllCustomersRequest) {
    return {
        type: aws_crt_1.eventstream.MessageType.ApplicationMessage,
        payload: JSON.stringify(normalizeGetAllCustomersRequest(getAllCustomersRequest))
    };
}
exports.serializeGetAllCustomersRequestToEventstreamMessage = serializeGetAllCustomersRequestToEventstreamMessage;
function normalizeGetAllCustomersResponse(getAllCustomersResponse) {
    let normalized = {};
    eventstream_rpc_utils.setDefinedArrayProperty(normalized, 'customers', getAllCustomersResponse.customers, normalizeCustomer);
    return normalized;
}
exports.normalizeGetAllCustomersResponse = normalizeGetAllCustomersResponse;
function deserializeGetAllCustomersResponse(getAllCustomersResponse) {
    eventstream_rpc_utils.setDefinedArrayProperty(getAllCustomersResponse, 'customers', getAllCustomersResponse.customers, deserializeCustomer);
    return getAllCustomersResponse;
}
exports.deserializeGetAllCustomersResponse = deserializeGetAllCustomersResponse;
function validateGetAllCustomersResponse(getAllCustomersResponse) {
    eventstream_rpc_utils.validateValueAsOptionalArray(getAllCustomersResponse.customers, validateCustomer, 'customers', 'GetAllCustomersResponse');
}
exports.validateGetAllCustomersResponse = validateGetAllCustomersResponse;
function deserializeEventstreamMessageToGetAllCustomersResponse(message) {
    const payload_text = (0, util_utf8_browser_1.toUtf8)(new Uint8Array(message.payload));
    let response = JSON.parse(payload_text);
    deserializeGetAllCustomersResponse(response);
    return response;
}
exports.deserializeEventstreamMessageToGetAllCustomersResponse = deserializeEventstreamMessageToGetAllCustomersResponse;
function normalizeGetAllProductsRequest(getAllProductsRequest) {
    let normalized = {};
    return normalized;
}
exports.normalizeGetAllProductsRequest = normalizeGetAllProductsRequest;
function deserializeGetAllProductsRequest(getAllProductsRequest) {
    return getAllProductsRequest;
}
exports.deserializeGetAllProductsRequest = deserializeGetAllProductsRequest;
function validateGetAllProductsRequest(getAllProductsRequest) {
}
exports.validateGetAllProductsRequest = validateGetAllProductsRequest;
function serializeGetAllProductsRequestToEventstreamMessage(getAllProductsRequest) {
    return {
        type: aws_crt_1.eventstream.MessageType.ApplicationMessage,
        payload: JSON.stringify(normalizeGetAllProductsRequest(getAllProductsRequest))
    };
}
exports.serializeGetAllProductsRequestToEventstreamMessage = serializeGetAllProductsRequestToEventstreamMessage;
function normalizeGetAllProductsResponse(getAllProductsResponse) {
    let normalized = {};
    eventstream_rpc_utils.setDefinedArrayProperty(normalized, 'products', getAllProductsResponse.products, normalizeProduct);
    return normalized;
}
exports.normalizeGetAllProductsResponse = normalizeGetAllProductsResponse;
function deserializeGetAllProductsResponse(getAllProductsResponse) {
    eventstream_rpc_utils.setDefinedArrayProperty(getAllProductsResponse, 'products', getAllProductsResponse.products, deserializeProduct);
    return getAllProductsResponse;
}
exports.deserializeGetAllProductsResponse = deserializeGetAllProductsResponse;
function validateGetAllProductsResponse(getAllProductsResponse) {
    eventstream_rpc_utils.validateValueAsOptionalMap(getAllProductsResponse.products, validateProduct, 'products', 'GetAllProductsResponse');
}
exports.validateGetAllProductsResponse = validateGetAllProductsResponse;
function deserializeEventstreamMessageToGetAllProductsResponse(message) {
    const payload_text = (0, util_utf8_browser_1.toUtf8)(new Uint8Array(message.payload));
    let response = JSON.parse(payload_text);
    deserializeGetAllProductsResponse(response);
    return response;
}
exports.deserializeEventstreamMessageToGetAllProductsResponse = deserializeEventstreamMessageToGetAllProductsResponse;
//# sourceMappingURL=model_utils.js.map